apiVersion: batch/v1
kind: Job
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ awx_name }}
  name: {{ awx_name }}
  namespace: {{ namespace }}
spec:
  backoffLimit: 3
  completions: 1
  parallelism: 1
  template:
    metadata:
      labels:
        name: {{ awx_name }}
    spec:
      automountServiceAccountToken: false
      containers:
      - command:
        - /bin/bash
        - -c
        - /init-awx.sh
        env:
        - name: AWX_ADMIN_USER
          valueFrom:
            secretKeyRef:
              key: admin-user
              name: {{ awx_name }}-admin
        - name: AWX_ADMIN_PASSWORD
          valueFrom:
            secretKeyRef:
              key: admin-password
              name: {{ awx_name }}-admin
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if do_ldap %}
            - name: OPENLDAP_BASE
              valueFrom:
                secretKeyRef:
                  key: directory-root
                  name: {{ ldap_secret_name }}
            - name: OPENLDAP_BIND_DN_PREFIX
              value: cn=awx,ou=services
            - name: OPENLDAP_BIND_PW
              valueFrom:
                secretKeyRef:
                  key: awx-password
                  name: {{ ldap_secret_name }}
            - name: OPENLDAP_DOMAIN
              value: {{ root_domain }}
            - name: OPENLDAP_HOST
{% if ldaps_address | default(False) and 0 == 1 %}
              value: {{ ldaps_address | urlsplit('hostname') }}
            - name: OPENLDAP_PORT
              value: "{{ ldaps_address | urlsplit('port') }}"
            - name: OPENLDAP_PROTO
              value: ldaps
{% else %}
              value: {{ ldap_address | urlsplit('hostname') }}
            - name: OPENLDAP_PORT
              value: "{{ ldap_address | urlsplit('port') }}"
            - name: OPENLDAP_PROTO
              value: ldap
{% endif %}
            - name: OPENLDAP_USERS_OBJECTCLASS
{% if do_fusion %}
              value: gosaAccount
{% else %}
              value: {{ awx_ldap_user_objectclass }}
{% endif %}
            - name: POSTGRES_DB
              valueFrom:
                secretKeyRef:
                  key: database-name
                  name: {{ awx_pg_name }}
            - name: POSTGRES_HOST
              value: {{ awx_pg_name }}
            - name: POSTGRES_PASS
              valueFrom:
                secretKeyRef:
                  key: database-password
                  name: {{ awx_pg_name }}
            - name: POSTGRES_USER
              valueFrom:
                secretKeyRef:
                  key: database-user
                  name: {{ awx_pg_name }}
{% endif %}
        name: job
        image: {{ (opsimages | json_query("[?name=='awx'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        resources:
          limits:
            cpu: "{{ awx_init_cpu_limit }}"
            memory: "{{ awx_init_memory_limit }}"
          requests:
            cpu: "{{ awx_init_cpu_request }}"
            memory: "{{ awx_init_memory_request }}"
        volumeMounts:
        - mountPath: /etc/tower/SECRET_KEY
          name: awx-secret-key
          readOnly: true
          subPath: SECRET_KEY
        - mountPath: /etc/tower/conf.d/
          name: awx-application-credentials
          readOnly: true
        - mountPath: /etc/tower/settings.py
          name: awx-application-config
          readOnly: true
          subPath: settings.py
        - mountPath: /init-awx.sh
          name: init-awx-job
          subPath: init_awx.sh
          readOnly: true
{% if do_ldap %}
        - mountPath: /init-ldap.sh
          name: init-awx-job
          subPath: init_ldap.sh
          readOnly: true
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
      restartPolicy: Never
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-jobs
{% endif %}
      volumes:
      - configMap:
          items:
          - key: settings
            path: settings.py
          name: {{ awx_name }}
        name: awx-application-config
      - name: awx-application-credentials
        secret:
          items:
          - key: credentials_py
            path: credentials.py
          secretName: {{ awx_name }}
      - name: awx-secret-key
        secret:
          items:
          - key: secret_key
            path: SECRET_KEY
          secretName: {{ awx_name }}
      - name: init-awx-job
        configMap:
          defaultMode: 0755
          items:
          - key: init-awx-job
            path: init_awx.sh
{% if do_ldap %}
          - key: init-ldap-job
            path: init_ldap.sh
{% endif %}
          name: {{ awx_name }}-scripts
